/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var findOrCreate = require('mongoose-findorcreate');

var connection = mongoose.createConnection(config.mongodbAuthURL); // connect to our database

// schema
var userSchema = new Schema({
//	_id: String
}, {
		collection: 'users',
		strict: false,          // we don't declare all fields
		versionKey: false       // dont use _v (mongoose) for versioning
	});


userSchema.plugin(findOrCreate);

// model
var User = connection.model('users', userSchema);

User.closeConnection = function () {
	connection.close();
};

// make this available to our users in our Node applications
module.exports = User;