/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

var workManager = require('../modules/workManager');
const async = require('async');

module.exports = function () {
	var Exporter = {};

	Exporter.doExport = function (expImpPath) {
		var config = require('../modules/config');
		const fs = require('fs-extra');
		var Users = require('../models/user');
		workManager.workStarted();
		async.waterfall([
			
			function(callback){
				requester.getAllLocalGroups(function(err, groups){
					if(err){
						winston.error(err);
						callback(err);

					}
					if(groups.length){
						fs.ensureDir(expImpPath, function (err) {
							if (err) callback(err);
			
							var groupsFile = expImpPath + '/' + 'groups.json';
							fs.outputJson(groupsFile, groups, { spaces: 4 }, function (err) {
								if (err) callback(err);

								winston.info('Successfully Exported Groups to - ', groupsFile);
								winston.info(groups);//print groups about to be exported
								callback(null);//successful group export
			
							});
			
						});
					}
					else{
						winston.log("No groups to export");
						callback(null);
					}		
		
				});
			},
			
			function(callback){
				requester.getAllUsers(function(err, users){
					if(err){
						winston.error(err);
						callback(err);

					}
					if(users.trim().length){
						fs.ensureDir(expImpPath, function (err) {
							if (err) callback(err);
			
							var usersFile = expImpPath + '/' + 'users.json';
							fs.outputJson(usersFile, JSON.parse(users), { spaces: 4 }, function (err) {
								if (err) callback(err);

								winston.info('Successfully Exported Users to - ', usersFile);
								winston.info(users);//print users about to be exported
								callback(null);//successful users export
			
							});
			
						});
					}
					else{
						winston.log("No groups to export");
						callback(null);
					}		
		
				});
			}
		], 
		function(err, result){
			if(err){
				winston.error(err);
			}
			workManager.workEnded();

		});

	};

	return Exporter;
};